/*
  Base code for ArdSim LAN Library.
  Upload and connect buttons / switches to any
  digital inputs accordingly with your input config file
  (Analog pins are not used)

  Download ArdSim Library on the site.

  by Vlad Sychev 2015
  http://arduino.svglobe.com

  Many Thanks to Vlad and Roman for the best connectivity software for X-plane Hardware
  and for all of the help and support they have given

  Also, Thanks to Dave (on the svglobe.com forums) for his code assistance
*/



//*********************************************************NOT USING SPI***********************
#include "LedControl.h"        // -- include LedControl "anode" library
#include <ArdSimX.h>



//----------------Create LedControl------------------------------
//   LedControl (DATA IN, CLK, LOAD, # of 7219's, TRUE for Anode)
LedControl lc = LedControl(6, 7, 8, 2   , true); // for uno 

//-------------------lc (7219 chips and displays)------------------------
void printNumber5Digit(int displayNumber, long v, int decimalPoint)
{
  int ones = 0;
  int tens = 0;
  int hundreds = 0;
  int thou = 0;
  int tenthou = 0;

  ones = v % 10;
  v = v / 10;
  tens = v % 10;
  v = v / 10;
  hundreds = v % 10;
  v = v / 10;
  thou = v % 10;
  v = v / 10;
  tenthou = v % 10;

  lc.setDigit(displayNumber, 0, (byte)tenthou, (decimalPoint == 1));
  lc.setDigit(displayNumber, 1, (byte)thou, (decimalPoint == 2));
  lc.setDigit(displayNumber, 2, (byte)hundreds, (decimalPoint == 3));
  lc.setDigit(displayNumber, 3, (byte)tens, (decimalPoint == 4));
  lc.setDigit(displayNumber, 4, (byte)ones, (decimalPoint == 5));


}
void printNumber4Digit(int displayNumber, long v, int decimalPoint)
{
  int ones = 0;
  int tens = 0;
  int hundreds = 0;
  int thou = 0;
  int tenthou = 0;

  ones = v % 10;
  v = v / 10;
  tens = v % 10;
  v = v / 10;
  hundreds = v % 10;
  v = v / 10;
  thou = v % 10;
  v = v / 10;
  tenthou = v % 10;
  lc.setChar(displayNumber, 0, ' ', false);
  lc.setDigit(displayNumber, 1, (byte)thou, (decimalPoint == 2));
  lc.setDigit(displayNumber, 2, (byte)hundreds, (decimalPoint == 3));
  lc.setDigit(displayNumber, 3, (byte)tens, (decimalPoint == 4));
  lc.setDigit(displayNumber, 4, (byte)ones, (decimalPoint == 5));
}
void printNumber3Digit(int displayNumber, long v, int decimalPoint)
{
  int ones = 0;
  int tens = 0;
  int hundreds = 0;
  int thou = 0;
  int tenthou = 0;

  ones = v % 10;
  v = v / 10;
  tens = v % 10;
  v = v / 10;
  hundreds = v % 10;
  v = v / 10;
  thou = v % 10;
  v = v / 10;
  tenthou = v % 10;

  lc.setChar(displayNumber, 0, ' ', false);
  lc.setChar(displayNumber, 1, ' ', false);
  lc.setDigit(displayNumber, 2, (byte)hundreds, (decimalPoint == 3));
  lc.setDigit(displayNumber, 3, (byte)tens, (decimalPoint == 4));
  lc.setDigit(displayNumber, 4, (byte)ones, (decimalPoint == 5));
}
void printNumber2Digit(int displayNumber, long v, int decimalPoint)
{
  int ones = 0;
  int tens = 0;
  int hundreds = 0;
  int thou = 0;
  int tenthou = 0;

  ones = v % 10;
  v = v / 10;
  tens = v % 10;
  v = v / 10;
  hundreds = v % 10;
  v = v / 10;
  thou = v % 10;
  v = v / 10;
  tenthou = v % 10;
  lc.setChar(displayNumber, 0, ' ', false);
  lc.setChar(displayNumber, 1, ' ', false);
  lc.setChar(displayNumber, 2, ' ', false);
  lc.setDigit(displayNumber, 3, (byte)tens, (decimalPoint == 4));
  lc.setDigit(displayNumber, 4, (byte)ones, (decimalPoint == 5));


}
void printNumber1Digit(int displayNumber, long v, int decimalPoint)
{
  int ones = 0;
  int tens = 0;
  int hundreds = 0;
  int thou = 0;
  int tenthou = 0;

  ones = v % 10;
  v = v / 10;
  tens = v % 10;
  v = v / 10;
  hundreds = v % 10;
  v = v / 10;
  thou = v % 10;
  v = v / 10;
  tenthou = v % 10;

  lc.setChar(displayNumber, 0, ' ', false);
  lc.setChar(displayNumber, 1, ' ', false);
  lc.setChar(displayNumber, 2, ' ', false);
  lc.setChar(displayNumber, 3, ' ', false);
  lc.setDigit(displayNumber, 4, (byte)ones, (decimalPoint == 5));


}

//------------------------------------------------
void setup()  {

  BoardNumber 1;

//-------------------lc wake up LED driver chips MAX7219-----------------------
  //number of devices was set when LedControlAnode was created
  int devices = lc.getDeviceCount();
  //initialize the devices in a loop
  for (int address = 0; address < devices; address++) {
    /*The MAX7219 is in power-saving mode on startup*/
    lc.shutdown(address, false);
    /* Set the brightness to a medium values */
    lc.setIntensity(address, 8);
    /* and clear the display */
    lc.clearDisplay(address);
  }

}

//------------------------------------------------------------
void loop()
{
  ArdSimScan;

}


//-------------------------------------------------------------
void ProgOut(byte id, float val)  {

  switch (id)
  {
    case 1: printNumber5Digit(0, val, 3); break;
    case 2: printNumber5Digit(1, val, 3); break;
    case 3: printNumber5Digit(2, val, 3); break;
    case 4: printNumber5Digit(3, val, 3); break;
    case 5: printNumber5Digit(4, val, 3); break;
    case 6: printNumber5Digit(5, val, 3); break;
    case 7: if (val < 10) printNumber2Digit (6, (val * 10), 4);
      else if (val < 100) printNumber3Digit (6, (val * 10), 4);
      else if (val < 1000) printNumber4Digit (6, (val * 10), 4);
      else printNumber5Digit(6, (val * 10), 4); break;
    case 8: if (val < 10) printNumber1Digit(7, val, 0);
      else if (val < 100) printNumber2Digit (7, val, 0);
      else if (val < 1000) printNumber3Digit (7, val, 0);
      else if (val < 10000) printNumber4Digit (7, val, 0);
      else printNumber5Digit (7, val, 0);
      break;
    case 9: if (val < 1000) printNumber3Digit (8, val, 0);
      else if (val < 10000) printNumber4Digit (8, val, 0); break;
    case 10: printNumber4Digit(9, val, 0); break;

  }
}



/*
   -----------------Ouput Config in Plugin-----------------
  1 0 sim/cockpit2/radios/actuators/com1_standby_frequency_hz
  2 0 sim/cockpit2/radios/actuators/com1_frequency_hz
  3 0 sim/cockpit2/radios/actuators/nav1_standby_frequency_hz
  4 0 sim/cockpit2/radios/actuators/nav1_frequency_hz
  5 0 sim/cockpit2/radios/actuators/nav2_standby_frequency_hz
  6 0 sim/cockpit2/radios/actuators/nav2_frequency_hz
  7 1 sim/cockpit2/radios/indicators/gps_dme_distance_nm
  8 0 sim/cockpit2/radios/indicators/gps_dme_speed_kts
  9 0 sim/cockpit2/radios/actuators/adf1_frequency_hz
  10 0 sim/cockpit2/radios/actuators/transponder_code

 
  

*/

